/*////////////////////////////////////////////////////////////////////////
Copyright (c) 1992 Electrotechnical Laboratry (ETL)

Permission to use, copy, modify, and distribute this material 
for any purpose and without fee is hereby granted, provided 
that the above copyright notice and this permission notice 
appear in all copies, and that the name of ETL not be 
used in advertising or publicity pertaining to this 
material without the specific, prior written permission 
of an authorized representative of ETL.
ETL MAKES NO REPRESENTATIONS ABOUT THE ACCURACY OR SUITABILITY 
OF THIS MATERIAL FOR ANY PURPOSE.  IT IS PROVIDED "AS IS", 
WITHOUT ANY EXPRESS OR IMPLIED WARRANTIES.
/////////////////////////////////////////////////////////////////////////
Content-Type:	program/C; charset=US-ASCII
Program:
Author:		Yutaka Sato <ysato@etl.go.jp>
Description:
History:
	921226	created
///////////////////////////////////////////////////////////////////////*/
#include <stdio.h>

main(){
	FILE *fp;
	int i;

	fp = fopen("active","r");
	if( fp == NULL )
		exit(-1);

	actcomp(fp,stdout);
	fclose(fp);
}

scan_sym(in,str)
	register FILE *in;
	char *str;
{	register char *sp;
	register int ch;

	sp = str;
	for(;;){
		if( (ch = getc(in)) == EOF )
			return -1;
		if( ch == ' ' )
			break;
		*sp++ = ch;
	}
	*sp = 0;
	return sp - str;
}

scan_num(in)
	register FILE *in;
{	register int ch;
	register int num;

	num = 0;
	for(;;){
		if( (ch = getc(in)) == EOF )
			return -1;
		if( ch == ' ' )
			break;
		num = num * 10 + (ch - '0');
	}
	return num;
}

char *allocString(str)
	char *str;
{	char *s;
	s = (char*)malloc(strlen(str)+1);
	return (char*)strcpy(s,str);
}

#define M_x	(0<<4)
#define M_y	(1<<4)
#define M_n	(2<<4)
#define M_m	(3<<4)

#define H_1	(0<<2)
#define H_2	(1<<2)
#define H_3	(2<<2)
#define H_4	(3<<2)

#define L_1	(0<<0)
#define L_2	(1<<0)
#define L_3	(2<<0)
#define L_4	(3<<0)

typedef struct {
	short	aleng;
	char	attrs[10];
	char	*group;
} Active;
typedef short Index;

#define MAXENT	4096
Active active[MAXENT];
Index activex[MAXENT];
int activen;

static scmp(a,b)
	register Index *a,*b;
{	register char *as,*bs;

	as = active[*a].group;
	bs = active[*b].group;
	while( *as && *as != *bs ){
		as++; bs++;
	}
	return *as - *bs;
}

actcomp(in,out)
	FILE *in,*out;
{	char group[1024];
	register char mod;
	register int ch,hi,lo,tag;
	register Active *ap;
	char *lp;

	activen = 0;
	for(;;){
		if( scan_sym(in,group) < 0 )
			goto eof;
		if( (hi = scan_num(in)) < 0 )
			goto eof;
		if( (lo = scan_num(in)) < 0 )
			goto eof;
		mod = getc(in);
		while( (ch = getc(in)) != '\n' )
			;
		tag = 0;

		if( 0x1000000 <= hi ) tag |= H_4;    else
		if( 0x10000   <= hi ) tag |= H_3;    else
		if( 0x100     <= hi ) tag |= H_2; /* else tag |= H_1; */

		if( 0x1000000 <= lo ) tag |= L_4;    else
		if( 0x10000   <= lo ) tag |= L_3;    else
		if( 0x100     <= lo ) tag |= L_2; /* else tag |= L_1; */

		if( mod == 'y' ) tag |= M_y; else
		if( mod == 'n' ) tag |= M_n; else
		if( mod == 'm' ) tag |= M_m;

		activex[activen] = activen;
		ap = &active[activen];

		lp = ap->attrs;
		*lp++ = tag;
		do { *lp++ = hi & 0xFF; hi = hi >> 8; } while( hi );
		do { *lp++ = lo & 0xFF; lo = lo >> 8; } while( lo );
		*lp = 0;
		ap->aleng = lp - ap->attrs;
		ap->group = allocString(group);
		activen++;
	}
eof:
	qsort(activex,activen,sizeof(Index),scmp);
	{	int ai;
		int copy;
		Active *pap;

		pap = 0;
		for(ai = 0; ai < activen; ai++){
			ap = &active[activex[ai]];
			fwrite(ap->attrs,1,ap->aleng,out);
			if( pap == 0 )
				copy = 0;
			else
			for(copy = 0; ;copy++)
				if( pap->group[copy] != ap->group[copy] )
					break;
			fprintf(out,"%c",copy+'0');
			fputs(&ap->group[copy],out);
			pap = ap;
		}
	}
	fprintf(stderr,"%d\n",activen);
}
